/***************************************************************/
/*                                                             */
/*  CSET.C                                                     */
/*                                                             */
/*  Contains definitons of MSC's _dos_XXXX functions.          */
/*                                                             */
/*  Copyright 1995 Andrew Wm. Graham                           */
/*                                                             */
/***************************************************************/
        struct dostime_t {
                   int hour,minute,second;
                 };

        struct dosdate_t {
                   int day,month,year;
                 };
/*
         OS/2 Date data structure for file-system functions.

         typedef struct _FDATE {
         USHORT  day:5;
         USHORT  month:4;
         USHORT  year:7;
          } FDATE;


         OS/2 Time data structure for file-system functions.

         typedef struct _FTIME {
         USHORT  twosecs:5;
         USHORT  minutes:6;
         USHORT  hours:5;
          } FTIME;
*/

#define INCL_DOSFILEMGR
#define INCL_DOSDATETIME
#include <os2.h>
#include <stdio.h>


int	_dos_open (char *name,int mode,int *handle)
{
  if ((*handle = _open (name,mode)) < 0)
    return (-1);
   else
    return (0);
}

void	_dos_close (int handle)
{
  _close (handle);
}

void	_dos_getftime (int handle,FDATE *date, FTIME *time)
{
/*  union REGS regs;
  regs.x.ax = 0x5700;
  regs.x.bx = handle;
  int86 (0x21,&regs,&regs);
  *date = regs.x.dx;
  *time = regs.x.cx;
*/

 FILESTATUS3  FileInfoBuf;
 DosQueryFileInfo((HFILE) handle, 1,
                          &FileInfoBuf, sizeof(FILESTATUS3));
  *date = FileInfoBuf.fdateLastWrite;
  *time = FileInfoBuf.ftimeLastWrite;
}

void	_dos_setftime (int handle,unsigned date,unsigned time)
{
/*  union REGS regs;
  regs.x.ax = 0x5701;
  regs.x.bx = handle;
  regs.x.dx = date;
  regs.x.cx = time;
  int86 (0x21,&regs,&regs);
*/
 FILESTATUS  FileInfoBuf;
 DATETIME    DateTimeBuf;

    DosQueryFileInfo(handle, 1,
                     &FileInfoBuf, sizeof(FILESTATUS));
    DosGetDateTime(&DateTimeBuf);

    FileInfoBuf.fdateLastAccess.year = DateTimeBuf.year;
    FileInfoBuf.fdateLastAccess.month = DateTimeBuf.month;
    FileInfoBuf.fdateLastAccess.day = DateTimeBuf.day;
    FileInfoBuf.ftimeLastAccess.hours = DateTimeBuf.hours;
    FileInfoBuf.ftimeLastAccess.minutes = DateTimeBuf.minutes;
    FileInfoBuf.ftimeLastAccess.twosecs = 0;

    DosSetFileInfo(handle, 1,
                        &FileInfoBuf, sizeof(FILESTATUS));

}

void	_dos_getdate (struct dosdate_t *buf)
{
    DATETIME    DateTimeBuf;
    DosGetDateTime(&DateTimeBuf);

    buf->day = DateTimeBuf.day;
    buf->month = DateTimeBuf.month;
    buf->year  = DateTimeBuf.year;
}

void	_dos_gettime (struct dostime_t *tloc)
{
    DATETIME    DateTimeBuf;
    DosGetDateTime(&DateTimeBuf);
    tloc->hour =   DateTimeBuf.hours;
    tloc->minute = DateTimeBuf.minutes;
    tloc->second = DateTimeBuf.seconds;

}

